"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const os_1 = __importDefault(require("os"));
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const find_up_1 = require("find-up");
const FILE_NAME = ".ghirc";
exports.DEFAULT_PATH = path_1.default.join(os_1.default.homedir(), FILE_NAME);
const defaultConfig = {
    token: null,
    login: null,
    queries: {},
};
function resolve(userConfig) {
    if (userConfig && !fs_1.default.existsSync(userConfig)) {
        throw new Error(`${userConfig} does not exists`);
    }
    const configPath = userConfig || find_up_1.sync([FILE_NAME]) || exports.DEFAULT_PATH;
    if (!configPath) {
        return defaultConfig;
    }
    try {
        return JSON.parse(fs_1.default.readFileSync(configPath, "utf8"));
    }
    catch (e) {
        return defaultConfig;
    }
}
exports.resolve = resolve;
